#
# This is the OpenShift ovn overlay network image.
# it provides an overlay network using ovs/ovn/ovn-kube
#
# The standard name for this image is ovn-kube

# Notes:
# This is for a build where the ovn-kubernetes utilities
# are built in this Dockerfile and included in the image (instead of the rpm)
#

FROM openshift/golang-builder:1.12 AS builder
ENV __doozer=update BUILD_RELEASE=202006290519.p0 BUILD_VERSION=v4.3.28 OS_GIT_MAJOR=4 OS_GIT_MINOR=3 OS_GIT_PATCH=28 OS_GIT_TREE_STATE=clean OS_GIT_VERSION=4.3.28-202006290519.p0 
ENV __doozer=merge OS_GIT_COMMIT=1d9574b OS_GIT_VERSION=4.3.28-202006290519.p0-1d9574b SOURCE_DATE_EPOCH=1586463479 SOURCE_GIT_COMMIT=1d9574bfc80b3947fe2246249b8c58057c155c20 SOURCE_GIT_TAG=v0.3.11-1023-g1d9574bf SOURCE_GIT_URL=https://github.com/openshift/ovn-kubernetes 

WORKDIR /go-controller
COPY go-controller/ .

# build the binaries
RUN CGO_ENABLED=0 make
RUN CGO_ENABLED=0 make windows

FROM openshift/ose-cli:v4.3.28.20200629.051926 AS cli
ENV __doozer=update BUILD_RELEASE=202006290519.p0 BUILD_VERSION=v4.3.28 OS_GIT_MAJOR=4 OS_GIT_MINOR=3 OS_GIT_PATCH=28 OS_GIT_TREE_STATE=clean OS_GIT_VERSION=4.3.28-202006290519.p0 
ENV __doozer=merge OS_GIT_COMMIT=1d9574b OS_GIT_VERSION=4.3.28-202006290519.p0-1d9574b SOURCE_DATE_EPOCH=1586463479 SOURCE_GIT_COMMIT=1d9574bfc80b3947fe2246249b8c58057c155c20 SOURCE_GIT_TAG=v0.3.11-1023-g1d9574bf SOURCE_GIT_URL=https://github.com/openshift/ovn-kubernetes 

FROM openshift/ose-base:v4.3.28.20200629.051926
ENV __doozer=update BUILD_RELEASE=202006290519.p0 BUILD_VERSION=v4.3.28 OS_GIT_MAJOR=4 OS_GIT_MINOR=3 OS_GIT_PATCH=28 OS_GIT_TREE_STATE=clean OS_GIT_VERSION=4.3.28-202006290519.p0 
ENV __doozer=merge OS_GIT_COMMIT=1d9574b OS_GIT_VERSION=4.3.28-202006290519.p0-1d9574b SOURCE_DATE_EPOCH=1586463479 SOURCE_GIT_COMMIT=1d9574bfc80b3947fe2246249b8c58057c155c20 SOURCE_GIT_TAG=v0.3.11-1023-g1d9574bf SOURCE_GIT_URL=https://github.com/openshift/ovn-kubernetes 

USER root

ENV PYTHONDONTWRITEBYTECODE yes

# install needed rpms - openvswitch must be 2.10.4 or higher
# install selinux-policy first to avoid a race
RUN yum install -y  \
	selinux-policy && \
	yum clean all

RUN INSTALL_PKGS=" \
	PyYAML openssl firewalld-filesystem \
	libpcap iproute strace \
	openvswitch2.13 openvswitch2.13-devel \
	ovn2.13 ovn2.13-central ovn2.13-host ovn2.13-vtep \
	containernetworking-plugins yum-utils \
	" && \
	yum install -y --setopt=tsflags=nodocs --setopt=skip_missing_names_on_install=False $INSTALL_PKGS && \
	yum clean all && rm -rf /var/cache/*

RUN mkdir -p /var/run/openvswitch && \
    mkdir -p /var/run/ovn && \
    mkdir -p /etc/cni/net.d && \
    mkdir -p /opt/cni/bin && \
    mkdir -p /usr/libexec/cni/ && \
    mkdir -p /root/windows/

COPY --from=builder /go-controller/_output/go/bin/ovnkube /usr/bin/
COPY --from=builder /go-controller/_output/go/bin/ovn-kube-util /usr/bin/
COPY --from=builder /go-controller/_output/go/bin/ovn-k8s-cni-overlay /usr/libexec/cni/ovn-k8s-cni-overlay
COPY --from=builder /go-controller/_output/go/bin/windows/hybrid-overlay.exe /root/windows/

COPY --from=cli /usr/bin/oc /usr/bin/
RUN ln -s /usr/bin/oc /usr/bin/kubectl
RUN stat /usr/bin/oc

# copy git commit number into image
COPY .git/HEAD /root/.git/HEAD
COPY .git/refs/heads/ /root/.git/refs/heads/

# ovnkube.sh is the entry point. This script examines environment
# variables to direct operation and configure ovn
COPY dist/images/ovnkube.sh /root/
COPY dist/images/ovn-debug.sh /root/

# iptables wrappers
COPY ./dist/images/iptables-scripts/iptables /usr/sbin/
COPY ./dist/images/iptables-scripts/iptables-save /usr/sbin/
COPY ./dist/images/iptables-scripts/iptables-restore /usr/sbin/
COPY ./dist/images/iptables-scripts/ip6tables /usr/sbin/
COPY ./dist/images/iptables-scripts/ip6tables-save /usr/sbin/
COPY ./dist/images/iptables-scripts/ip6tables-restore /usr/sbin/
COPY ./dist/images/iptables-scripts/iptables /usr/sbin/


WORKDIR /root
ENTRYPOINT /root/ovnkube.sh

LABEL \
        io.k8s.display-name="ovn kubernetes" \
        io.k8s.description="This is a component of OpenShift Container Platform that provides an overlay network using ovn." \
        summary="This is a component of OpenShift Container Platform that provides an overlay network using ovn." \
        io.openshift.tags="openshift" \
        maintainer="Phil Cameron <pcameron@redhat.com>" \
        License="GPLv2+" \
        vendor="Red Hat" \
        name="openshift/ose-ovn-kubernetes" \
        com.redhat.component="ose-ovn-kubernetes-container" \
        io.openshift.maintainer.product="OpenShift Container Platform" \
        io.openshift.maintainer.component="Networking" \
        io.openshift.maintainer.subcomponent="ovn-kubernetes" \
        release="202006290519.p0" \
        io.openshift.build.commit.id="1d9574bfc80b3947fe2246249b8c58057c155c20" \
        io.openshift.build.source-location="https://github.com/openshift/ovn-kubernetes" \
        io.openshift.build.commit.url="https://github.com/openshift/ovn-kubernetes/commit/1d9574bfc80b3947fe2246249b8c58057c155c20" \
        version="v4.3.28"

